##########################################################################
###              CHANNELTALK STATISTICS 2.0 for Eggdrop 1.3            ###
###                     Developed by Wiking 1998		       ###
###	  <wiking@uniyar.ac.ru> http://www.uniyar.ac.ru/~wiking        ###
###              Idea by Goblet 1997 email: goblet@sci.fi              ###
##########################################################################

# This script gathers information on how many words, letters, modes, topics, 
# actions and so have been done by users of channel and top of them will 
# created (in html forms, also accessable in dcc).
# Ordering is choosen by user.

##########################################################################
### NOTES: This script uses xtra-field in userfile and flags 1 & 2,    ###
###        so it WILL interfere with other scripts using those!        ###
##########################################################################
## Please email me and tell the url where your stats are running!       ##
## Report me if bugs found.                                             ##
##########################################################################

#     Hello to Goblet for good ideas (not only about this script)!!!
  
# P.S. test page: http://www.uniyar.ac.ru/~wiking/Irc/Wwwwstat/member_words.htm

##########################################################################
## ================== DCC COMMANDS TO HANDLE THE STATS ================ ##
##########################################################################
##                      (only masters can use these)
## CLRUSER [<handle>|*]
##    Sets somebody's all stats to 0 
## SUMUSER <handle1> <handle2>
##    Adds handle2's hostmask(s) and stats to handle1 and deletes handle2
## DOSTATS [1]
##    Instantly creates the new html-files (1-to clear cache).
## WWWTOP [num] [words|spent|comments|letters|kick|mode|topc|acti] 
##    Show top [num] of user with corresponding ordering"
## STATHELP
##    Short descriptions of commands
## W_
##    Show handles preceding with _
## WWWTOPDEL
##    Delete all users talk less than 200 words (not bot and not op)

## ================ SPECIAL FLAGS USED BY THIS SCRIPT: ===================
## 1 = Do not include this user to the list output. (counting still works)
## 2 = Lock this handle, if someone uses same nick, he'll get handle _nick
##                                                   if _nick not used yet

##########################################################################
## ============================== SETTINGS ============================ ##
##########################################################################
## Result files (not including extension htm)
## Real file names have tail [words|spent|comments|letters|kick|mode|topc|acti]
## depending of ordering: i.e. $wwwfile_<...>.htm
## Physical location
set wwwfile "/Your-www-directory/Wwwwstat/member"
## WWW location
set wwwurl "http://www.your-server/~you/Wwwwstat/member"

## Tag for the output, if you want to use your own colors etc.
set bodytag "<body bgcolor=#C0C0C0 text=#000000>"

## Which channel should stat?
set statchan "#channel"

## Interval of updating (in minutes)
set updatestat 30

######################################################################
## Less important parameters (you probably not needed to correct it) #
######################################################################
# Enable/disable script to refresh html-files
# Statistic calculation is not disabled
set wwwtop_enable 1

## Amount of top talkers
set toptalkers 15

## Should userfile be saved same time as the statistics-web page updates?
set saveonupdate 0

## Should bot learn new users when they start talking on channel?
## not good idea if you don't like BIG userfile... 1=enable 0=disable
## if a user with same nick already exists, _$nick created
## if the later exists hostmask added to him.
## Hostmask is not added if user has any local/global flag of "mnjfto"
## or user is locked by setting flag +2 
## In the last case, nick will became "someone" and hostmask will be added to him
set autoadd 0
set nickoncollision "someone"

## Set to 1 if your system is able to execute { exec mv <file1> <file2> }
## for unix it is preferably 1, for windows - 0
set mv_cptbl 1

##########################################################################
### -------------------------- CODE BEGINS HERE  --------------------- ###
##########################################################################
# Clearing cache on rehash!
# catch {unset w_ara}

proc p_mask { a } {
  return "[maskhost *[string trimleft $a ^+=-~]]"
  }
  

proc p_have_any_flag {hand} {
  foreach ch [channels] {
    set a [chattr $hand $ch]
    if {[regexp \[mnjfto\] $a] } { return 1 }
    }
  return 0
  }


# How many words in phrase
proc h_m_w { text } {
  regsub -all "\[!.,:;?]" $text " " text
  regsub -all " +" $text " " text
  set text [string trim $text]
  return [llength [split $text " "]]
  }

  
# How many letters in phrase
proc h_m_l { text } {
  regsub -all " +" $text " " text
  set text [string trim $text]
  return [expr [string length $text] - [llength [split $text " "]] + 1]
  }
  

proc user_get {handle key} {
  set t [getuser $handle XTRA $key]
  if {$t == ""} { set t 0 }
  return $t
  }


proc user_set {handle key data} {
  global w_change
  set w_change($handle) "!"
  setuser $handle XTRA $key $data
  }


proc cmp {one two} {
  if {[lindex $one 0] > [lindex $two 0]} { 
    return 1
  } elseif {[lindex $one 0] < [lindex $two 0]} {
    return -1
  } else {
    return 0
  }
}


proc sechour { secs } {
  set s [expr $secs % 60]
  set secs [expr $secs / 60]
  set m [expr $secs % 60]
  set secs [expr $secs / 60]
  set h [expr $secs % 24]
  set secs [expr $secs / 24]
  set d $secs
  set r "" 
  if {$d} { set r "${d}d, " }
  if {$d || $h} { set r "$r${h}h, " }
  if {$d || $h || $m} { set r "$r${m}m" }
  if {($d || $h || $m) && $s} { set r "$r, " }
  if {!($d || $h || $m) || $s} { set r "$r${s}s" }
  return $r
  }


proc auto_adduser {nick uhost hand chan text} {
  global nickoncollision statchan
  set nik $nick
  if {![onchan $nick $chan]} { return }
  if {[validuser $nick]} {
    if {[p_have_any_flag $nick] || [matchattr $nick 2]} {
      set nick [string range "_$nick" 0 8]
      }
    if {[validuser $nick]} {
      if {[p_have_any_flag $nick] || [matchattr $nick 2]} { 
        set nick $nickoncollision 
        }
      if {[validuser $nick]} {
        # ADD NEW HOST ONLY!
        setuser $nick HOSTS "[p_mask $uhost]"
        putlog "Learned hostmask [p_mask $uhost] for $nick"
        user_set $hand "words" [expr [user_get $hand "words"] + [h_m_w $text]]
        user_set $hand "comments" [expr [user_get $hand "comments"] + 1]
        user_set $hand "letters" [expr [user_get $hand "letters"] + [h_m_l $text]]
        return 1    
        }
      } 
    }
  # CREATING NEW USER!  
  adduser $nick "[p_mask $uhost]"
  putlog "Learned user $nick [p_mask $uhost] for $statchan"
  setuser $nick COMMENT "Auto added by wwwwstat-script"
  chattr $nick -qwertyuiopasdfghjklzxcvbnm
  user_set $nick "words" [h_m_w $text]
  user_set $nick "comments" 1
  user_set $nick "letters" [h_m_l $text]
  user_set $nick "mode" 0
  user_set $nick "kick" 0
  user_set $nick "topc" 0
  user_set $nick "acti" 0
  return 1
  }


bind pubm - * count_words
proc count_words {nick uhost hand chan text} {
  global autoadd statchan
  if {[string tolower $statchan] != [string tolower $chan]} { return 0 }
  if {![validuser $hand]} {
    if {$autoadd} {
      set uhost [getchanhost $nick $chan]
      auto_adduser $nick $uhost $hand $chan $text
      }
    return 0
    }
  user_set $hand "words" [expr [user_get $hand "words"] + [h_m_w $text]]
  user_set $hand "comments" [expr [user_get $hand "comments"] + 1]
  user_set $hand "letters" [expr [user_get $hand "letters"] + [h_m_l $text]]
  return 0
  }


################
# DCC-Commands #
################
bind dcc m stathelp dcc_stathelp
proc dcc_stathelp {hand idx text} {
  global botnick
  putdcc $idx "HELP ON STATWWW V2.0"
  putdcc $idx "DCC COMMANDS:"
  putdcc $idx "  .CLRUSER \[<handle>|<*>] Sets somebody's stats to 0"
  putdcc $idx "  .SUMUSER <handle1> <handle2> Adds handle2's hostmask(s) and stats to handle1 and deletes handle2"
  putdcc $idx "  .DOSTATS \[1] Instantly creates the new html-files (1-to clear cache)"
  putdcc $idx "  .WWWTOP \[num] \[words|spent|comments|letters|kick|mode|topc|acti] Show top \[num] of user"
  putdcc $idx "  .W_ Show handles preceding with _"
  putdcc $idx "  .WWWTOPDEL (+n) Delete users talk less than 200 words"
  return 1
  }

bind dcc m dostats dcc_dostats
proc dcc_dostats {hand idx text} {
   global w_ara
   if {$text=="1"} {
     catch { unset w_ara }
     }
   do_stats
   putdcc $idx "Updated webfiles."
   return 1
   }

## .sumuser sums two usernames' stats together, if automatic-add-user
## has created two entries to same user...
bind dcc m sumuser dcc_sumuser
proc dcc_sumuser {hand idx text} {
  global statchan 
  set text [string trim $text]
  set realuser [lindex [split $text { }] 0]
  set fakeuser [lindex [split $text { }] 1]
  if {[validuser $realuser] != 1} {return 0}
  if {[validuser $fakeuser] != 1} {return 0}
  set foo [expr {[user_get $realuser "spent"] + [user_get $fakeuser "spent"]}]
  user_set $realuser "spent" $foo
  set foo [expr {[user_get $realuser "words"] + [user_get $fakeuser "words"]}]
  user_set $realuser "words" $foo
  set foo [expr {[user_get $realuser "comments"] + [user_get $fakeuser "comments"]}]
  user_set $realuser "comments" $foo
  set foo [expr {[user_get $realuser "letters"] + [user_get $fakeuser "letters"]}]
  user_set $realuser "letters" $foo
  set foo [expr {[user_get $realuser "kick"] + [user_get $fakeuser "kick"]}]
  user_set $realuser "kick" $foo
  set foo [expr {[user_get $realuser "mode"] + [user_get $fakeuser "mode"]}]
  user_set $realuser "mode" $foo
  set foo [expr {[user_get $realuser "topc"] + [user_get $fakeuser "topc"]}]      
  user_set $realuser "topc" $foo   
  set foo [expr {[user_get $realuser "acti"] + [user_get $fakeuser "acti"]}]
  user_set $realuser "acti" $foo
  set foo [user_get $fakeuser laston]
  if {[user_get $realuser laston] < $foo} {
      user_set $realuser laston $foo
     }
  unset foo
  foreach h [getuser $fakeuser hosts] { 
    setuser $realuser HOSTS $h
    putlog "$h hostmask added to $realuser"
    }
  
  putlog "$fakeuser stats added to $realuser and $fakeuser deleted."
  deluser $fakeuser
  return 1
  }


bind dcc m w_ dcc_w_
proc dcc_w_ {hand idx text} {
  set i 10
  set all 0
  set x ""
  foreach u [userlist] {
    if {$i == 0} {
      putdcc $idx "$x"
      set i 10
      set x ""
      }
    if {[string match _* $u] } {
      set x "$x:$u"
      incr i -1
      incr all
      }
    }
  if {$x != ""} {
    putdcc $idx $x
    }
  putdcc $idx "Found $all matches"
  }


## .clruser handle clears somebody's statistics if he has flooded
## to get higher on the list (this has really happened ;-)

bind dcc m clruser dcc_formatuser
proc stat_clruser { text } {
  user_set $text "words" 0
  user_set $text "spent" 0
  user_set $text "comments" 0
  user_set $text "letters" 0
  user_set $text "kick" 0
  user_set $text "mode" 0
  user_set $text "topc" 0
  user_set $text "acti" 0
  }

proc stat_date_begin {} {
  global nick
  if {![validuser $nick]} { addbot $nick 127.0.0.1 }
  setuser $nick XTRA stat_beg "Started [date] at [time]"
  }

proc dcc_formatuser {hand idx text} {
  if { $text != "*" } {
    if {![validuser $text]} { 
      putlog "Not valid user"
    } else {
      putlog "Set parms of $text to 0"
      stat_clruser $text
      }
  } else {
    foreach i [userlist] { stat_clruser $i }
    stat_date_begin
    putlog "Set parms of all uses to 0"
    putlog "Start new statistics"
    }
  return 1
  }


bind dcc m wwwtop dcc_wwwtop
proc dcc_wwwtop {hand idx text} {
  global statchan
  set text [string trim $text]
  set y1 ""
  set y2 ""
  if {[llength $text] == 1} {
    set y1 [string trim $text]
  } elseif {[llength $text] > 1} {
    set y1 [string trim [lindex $text 0]]
    set y2 [string trim [lindex $text 1]]
    }
  #
  if {[regexp ^\[0-9\]+\$ $y2]} {
    set quantity $y2
    set ordering $y1
  } elseif {[regexp ^\[0-9\]+\$ $y1]} {
    set quantity $y1
    set ordering $y2
  } else {
    set quantity 10
    set ordering $y1
    }
  if {[lsearch "words spent comments letters kick mode topc acti" $ordering] == -1} {
    set ordering words
    }
  #
  set foolist ""
  foreach i [userlist] {
    if {![matchattr $i 1]} {
        set x [user_get $i $ordering]
	if {$x > 0} {
	  set foo "$x $i"
          lappend foolist $foo
	  }
        }
    }
  set foo $quantity
  if {[llength $foolist] < $foo} {
    set foo [llength $foolist]
    }
  set foolista [lsort -decreasing -command cmp $foolist]
  #
  putdcc $idx "*** Top $foo talkers on channel $statchan (by $ordering) ***"
  putdcc $idx "No:Nick:Words:Pubs:Lettrs:Kiks:Mods:Tpcs:Acts:Spent"
  set no 0
  foreach i $foolista {
    if {$no == $quantity} { break }
    incr no
    set handle [lindex $i 1]
    set chost  [getuser $handle hosts]
    set w_word [user_get $handle "words"]
    set w_spen [sechour [user_get $handle "spent"]]
    set w_comm [user_get $handle "comments"]
    set w_letr [user_get $handle "letters"]
    set w_kick [user_get $handle "kick"]
    set w_mode [user_get $handle "mode"]
    set w_topc [user_get $handle "topc"]
    set w_acti [user_get $handle "acti"]
    putdcc $idx "$no:$handle:$w_word:$w_letr:$w_kick:$w_mode:$w_topc:$w_acti:$w_spen"
    }
  }


bind dcc n wwwtopdel dcc_wwwtopdel
proc dcc_wwwtopdel {hand idx text} {
  set n 0
  foreach i [userlist -b] {
    if {![matchattr $i m] && ![matchattr $i o] && [user_get $i words] < 200} {
      deluser $i
      incr n
      }
    }
  putlog "TOP deleting ($n) done." 
  }


bind dcc n top_file dcc_wwwtop_file
proc dcc_wwwtop_file {hand idx text} {
  set foolist ""
  foreach i [userlist] {
    set foo "[user_get $i words] $i"
    lappend foolist $foo
    }
  set foolista [lsort -decreasing -command cmp $foolist]
  set f [open "/home/wiking/bot/eggdrop/scripts/WWW/beta/listing" w]
  foreach i $foolista {
    puts $f [lindex $i 1]
    }
  close $f
  putdcc $idx "File created."
  return 1
  }
 
#######################
# End of DCC-Commands #
#######################


###############
# Filling ara #
###############
proc ara_fill { ordering } { 
  global w_ara w_mini w_ii w_change toptalkers
  if {[llength [array names w_ara "h${ordering}*"]] != $toptalkers} {
    foreach i [array names w_ara "h${ordering}*"] {
      unset w_ara($i)
      }
    set ul [userlist]
  } else {
    set ul ""
    foreach i [array names w_change] {
      if {[validuser $i]} {
        lappend ul $i
	}
      }
    for {set i 0} {$i < $toptalkers} {incr i} {
      set t $w_ara(h$ordering$i)
      if {$t !="" && [validuser $t] && [lsearch -exact $ul $t] == -1} {
        lappend ul $t
	}
      }
    }

  for {set i 0} {$i < $toptalkers} {incr i} {
    set w_ara(h$ordering$i) ""
    set w_ara(w$ordering$i) 0
    }
  set w_mini($ordering) 0
  set w_ii($ordering) 0

  foreach hnd $ul {
    if {![matchattr $hnd 1]} {
      set foo "[user_get $hnd $ordering]"
      if {$foo > $w_mini($ordering)} {
        set tmp $w_ii($ordering)
        set w_ara(h$ordering$tmp) $hnd
	set w_ara(w$ordering$tmp) $foo
	set w_mini($ordering) $foo
	for {set i 0} {$i < $toptalkers} {incr i} {
	  if {$w_mini($ordering) > $w_ara(w$ordering$i)} {
	    set w_mini($ordering) $w_ara(w$ordering$i) 
	    set w_ii($ordering) $i
	    }
	  }
	}
      }
    }

  set foolist ""
  for {set i 0} {$i < $toptalkers} {incr i} {
    if {$w_ara(w$ordering$i) > 0} {
      lappend foolist "$w_ara(w$ordering$i) $w_ara(h$ordering$i)"    
      }
    }
  global foolista  
  set foolista [lsort -decreasing -command cmp $foolist]  
  }


proc do_stats {} {
  global wwwfile updatestat statchan bodytag toptalkers mv_cptbl botnick wwwurl nick w_change
  if {![validuser $nick] || [getuser $nick XTRA stat_beg] == ""} {
    stat_date_begin
    }
  set wor { words spent comments letters kick mode topc acti } 
  set wora(words) "Words"
  set wora(spent) "Spent on"
  set wora(comments) "Pubs"
  set wora(letters) "Letters"
  set wora(kick) "Kiks"
  set wora(mode) "Mods"
  set wora(topc) "Tpcs"
  set wora(acti) "Acts"
  #
  foreach ordering $wor {
  ##############
  # MAIN CYCLE #
  ##############
  set destfile ${wwwfile}_${ordering}.htm
  if {$mv_cptbl} { 
    set fd [open ${wwwfile}_t w] 
  } else { 
    set fd [open $destfile w] 
    }
  global foolista
  ara_fill $ordering

  set foo $toptalkers
  if {[llength $foolista] < $foo} {
    set foo [llength $foolista]
    }

  puts $fd "<meta http-equiv=\"Refresh\" content=[expr 60*$updatestat]>"
  puts $fd "<!-- Page created due to Wiking's script, based on Goblet's idea-->"
  puts $fd "<html><head><title>Top $foo talkers on channel $statchan</title></head>"
  puts $fd $bodytag
  puts $fd "<center><h1>Top $foo talkers on channel $statchan</h1>"
  puts $fd "Ordered by \"$wora($ordering)\" (to change it click corresponding table field).<BR>"
  puts $fd "<P><table border=2 cellpadding=1><tr align=right>"
  puts $fd "<th>No</th>"
  puts $fd "<th align=center>Nick</th>"
  puts $fd "<th><A HREF=${wwwurl}_words.htm>Words</A></th>"
  puts $fd "<th><A HREF=${wwwurl}_comments.htm>Pubs</A></th>"
  puts $fd "<td>W/P</th>"
  puts $fd "<th><A HREF=${wwwurl}_letters.htm>Lettrs</A></th>"
  puts $fd "<th><A HREF=${wwwurl}_kick.htm>Kiks</A></th>"
  puts $fd "<th><A HREF=${wwwurl}_mode.htm>Mods</A></th>"
  puts $fd "<th><A HREF=${wwwurl}_topc.htm>Tpcs</A></th>"
  puts $fd "<th><A HREF=${wwwurl}_acti.htm>Acts</A></th>"
  puts $fd "<th><A HREF=${wwwurl}_spent.htm>Spent on</A></th>"
  puts $fd "<th>Last on</th>"
  set no 0
  
  foreach i $foolista {
    incr no
    set handle [lindex $i 1]
    set chost  [getuser $handle hosts]
    set w_word [user_get $handle "words"]
    set w_spen [sechour [user_get $handle "spent"]]
    set w_comm [user_get $handle "comments"]
    set w_letr [user_get $handle "letters"]
    set w_kick [user_get $handle "kick"]
    set w_mode [user_get $handle "mode"]
    set w_topc [user_get $handle "topc"]
    set w_acti [user_get $handle "acti"]

    if {$w_comm > 0} {
        set w_wordperpub "[expr {$w_word / $w_comm}]."
        append w_wordperpub "[expr {($w_word * 10 / $w_comm) - ($w_word / $w_comm *10)}]"
    } { set w_wordperpub 0 }

    set lastonchan [user_get $handle laston]
    if {$lastonchan == 0} { set lastonchan "Never" }  
    if {[handonchan $handle $statchan]} {
        set fooidle [getchanidle [hand2nick $handle $statchan] $statchan]
        if {$fooidle > 10} {
          set lastonchan "Idle [sechour [expr $fooidle*60]]"
        } else {
          set lastonchan "Now!"
          }
       }

    if {[onchansplit [hand2nick $handle $statchan] $statchan]} { set lastonchan "Split" }

    puts $fd "<tr align=right>"
    puts $fd "<td>$no</td>"
    puts $fd "<td align=center>$handle</td>"
    puts $fd "<td>$w_word</td>"
    puts $fd "<td>$w_comm</td>"
    puts $fd "<td>$w_wordperpub</td>"
    puts $fd "<td>$w_letr</td>"
    puts $fd "<td>$w_kick</td>"
    puts $fd "<td>$w_mode</td>"
    puts $fd "<td>$w_topc</td>"
    puts $fd "<td>$w_acti</td>"
    puts $fd "<td>$w_spen</td>"
    puts $fd "<td>$lastonchan</td>"
    }
  puts $fd "<tr>" 
  puts $fd "<td colspan=12 align=center><B>Total users: [countusers]</B></td>"
  puts $fd "</table></center><br>"
  puts $fd "Shorts accepted:<UL>"
  puts $fd "<LI>Words, Pubs, Lettrs - words, public phrases, letters said by Nick"
  puts $fd "<LI>W/P - relation Words/Pubs"
  puts $fd "<LI>Kiks, Mods, Tpcs, Acts - kicks, modes, topic changes, actions done by Nick"
  puts $fd "<LI>Spent on - time spent on $statchan by Nick"
  puts $fd "<LI>Last on - time Nick was on $statchan last time"
  puts $fd "</UL><HR WIDTH=75%>"
  puts $fd "<CENTER>"
  puts $fd "Created [date] at [time].<BR>"
  puts $fd "[getuser $nick XTRA stat_beg].<BR>"
  puts $fd "This page autoupdates every $updatestat minutes.<BR>"
  puts $fd "<A HREF=\"mailto:wiking@uniyar.ac.ru\">Wiking 1998</A>"
  puts $fd "</CENTER>"
  puts $fd "</body></html>"
  close $fd
  if {$mv_cptbl} { catch { exec mv ${wwwfile}_t $destfile } }
  }
catch { unset w_change }
}


bind splt - * set_utim_p
bind part - * set_utim_p
proc set_utim_p {nick uhost hand chan} {
  set_utim $nick $uhost $hand $chan foo
  }


bind sign - * set_utim
proc set_utim {nick uhost hand chan arg} {
  global statchan
  if {[string tolower $statchan] != [string tolower $chan]} { return 0 }
  if {[validuser $hand]} { user_set $hand laston "[date] at [time]" }
  }


bind mode - * set_umode
proc set_umode {nick uhost hand chan arg} {
   global statchan
   if {[string tolower $statchan] != [string tolower $chan]} { return 0 }
   if {[validuser $hand]} {
        set foo [user_get $hand "mode"]
        incr foo
        user_set $hand "mode" $foo
      }
   }


bind kick - * set_ukick
proc set_ukick {nick uhost hand chan knick reason} {
   global statchan
   if {[string tolower $statchan] != [string tolower $chan]} { return 0 }
   if {[validuser $hand]} {
        set foo [user_get $hand "kick"]
        incr foo
        user_set $hand "kick" $foo
      }
}


bind topc - * set_utopc
proc set_utopc {nick uhost hand chan topic} {
   global statchan
   if {[string tolower $statchan] != [string tolower $chan]} { return 0 }
   if {[validuser $hand]} {
     set foo [user_get $hand "topc"]
     incr foo
     user_set $hand "topc" $foo
     }
   }


bind raw - PRIVMSG wtop_action
proc wtop_action { uhost key arg } {
  global statchan
  if { [string tolower $statchan] == [string tolower [lindex $arg 0]] } {
    set arg [lreplace $arg 0 0]
    if { [string index $arg 0] == ":" } {
      set arg [string range $arg 1 end]
      }
    if { [string first "\001ACTION " $arg] == 0 } {
      set k [expr [string first ! $uhost] - 1]
      set hand [nick2hand [string range $uhost 0 $k] $statchan]
      if {[validuser $hand]} {
        set foo [user_get $hand "acti"]
        incr foo
        user_set $hand "acti" $foo
        }
      }
    }
  return 0
  }


####################
# Timer's pribluda #
####################
proc do_stats_run {} {
  global updatestat saveonupdate wwwtop_enable
  if {$wwwtop_enable} {
    do_stats
    if {$saveonupdate == 1} { save }
    if { ![string match "* do_stats_run *" [timers]] } { 
      timer $updatestat do_stats_run
      }
    }
  }

proc do_stats_spent {} {
  global statchan botnick
  if {[onchan $botnick $statchan]} { 
    foreach i [chanlist $statchan] {
      set h [nick2hand $i $statchan]
      if {[validuser $h]} {
        set s [user_get $h "spent"]
        set s [expr $s + 5]
        user_set $h "spent" $s
        }
      }
    }
  if { ![string match "* do_stats_spent *" [utimers]] } { 
    utimer 5 do_stats_spent
    }
  }

proc do_stats_check {} {
  global updatestat
  if { ![string match "* do_stats_spent *" [utimers]] } { 
    utimer 5 do_stats_spent
    }
  if { ![string match "* do_stats_run *" [timers]] } { 
    timer $updatestat do_stats_run
    }
  if { ![string match "* do_stats_check *" [timers]] } { 
    timer 10 do_stats_check
    }
  }

do_stats_check

putlog "WWWStat 2.0 by Wiking 1998 loaded"
